<html>
<head>
<title>OGRE: Ogre::ResourceBackgroundQueue Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1ResourceBackgroundQueue.html">ResourceBackgroundQueue</a></div>
<h1>Ogre::ResourceBackgroundQueue Class Reference</h1><!-- doxytag: class="Ogre::ResourceBackgroundQueue" --><!-- doxytag: inherits="Ogre::Singleton" -->This class is used to perform <a class="el" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a> operations in a background thread.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::ResourceBackgroundQueue:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1ResourceBackgroundQueue-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#e04ad37bc376b91bf82c7e9da403d909">OGRE_THREAD_SYNCHRONISER</a> (initSync)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Init notification mutex (must lock before waiting on initCondition).  <a href="#e04ad37bc376b91bf82c7e9da403d909"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#74525d1f4e99a24afa3cc0800f0b6ce9">ResourceBackgroundQueue</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#407ce0c4668bdf5558e15f7f99c37fa8">~ResourceBackgroundQueue</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#ec6aec8fe94ec6bf29e8e7dc30d83319">setStartBackgroundThread</a> (bool startThread)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets whether or not a thread should be created and started to handle the background loading, or whether a user thread will call the appropriate hooks.  <a href="#ec6aec8fe94ec6bf29e8e7dc30d83319"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#b7ac1af9d48ef0177778522c5cb97a59">getStartBackgroundThread</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets whether or not a thread should be created and started to handle the background loading, or whether a user thread will call the appropriate hooks.  <a href="#b7ac1af9d48ef0177778522c5cb97a59"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#8842996829730ae05d3dd06c1a8224ad">initialise</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialise the background queue system.  <a href="#8842996829730ae05d3dd06c1a8224ad"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#e6e64b1d717c2a377a60772a5cbd8dec">shutdown</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shut down the background queue system.  <a href="#e6e64b1d717c2a377a60772a5cbd8dec"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#2543a3c0903bb5441c3b75f3c44d6cfa">initialiseResourceGroup</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *listener=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialise a resource group in the background.  <a href="#2543a3c0903bb5441c3b75f3c44d6cfa"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#be1b5ef553e2e9cafc6172af3f0edc1a">initialiseAllResourceGroups</a> (<a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *listener=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialise all resource groups which are yet to be initialised in the background.  <a href="#be1b5ef553e2e9cafc6172af3f0edc1a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#8caf7ad66b4c65608fa6a6dfc0b0f7cb">loadResourceGroup</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *listener=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Loads a resource group in the background.  <a href="#8caf7ad66b4c65608fa6a6dfc0b0f7cb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#e372f5db5fedec9648076e48407edf7c">unload</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;resType, const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *listener=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unload a single resource in the background.  <a href="#e372f5db5fedec9648076e48407edf7c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#91632d515e4c42970306bb8310df5790">unload</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;resType, <a class="el" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> handle, <a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *listener=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unload a single resource in the background.  <a href="#91632d515e4c42970306bb8310df5790"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#63632d3cd174ec2ba091145199e7be42">unloadResourceGroup</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *listener=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unloads a resource group in the background.  <a href="#63632d3cd174ec2ba091145199e7be42"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#b14cf2235526638f58ddbf234379219a">load</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;resType, const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;group, bool isManual=false, <a class="el" href="classOgre_1_1ManualResourceLoader.html">ManualResourceLoader</a> *loader=0, const <a class="el" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6">NameValuePairList</a> *loadParams=0, <a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *listener=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Load a single resource in the background.  <a href="#b14cf2235526638f58ddbf234379219a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#7165b27dcde57a8f6d49ca40c76bb75b">isProcessComplete</a> (<a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a> ticket)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns whether a previously queued process has completed or not.  <a href="#7165b27dcde57a8f6d49ca40c76bb75b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#8f60aa6699d6ea2f645cf375cf5ef817">_doNextQueuedBackgroundProcess</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Process a single queued background operation.  <a href="#8f60aa6699d6ea2f645cf375cf5ef817"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#20d36a810c38446862e913444fadad85">_initThread</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialise processing for a background thread.  <a href="#20d36a810c38446862e913444fadad85"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#d47c5ba2a6253b0fdb0aa9bf9d92f8f7">_queueFireBackgroundLoadingComplete</a> (<a class="el" href="classOgre_1_1Resource.html">Resource</a> *res)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Queue the firing of the 'background loading complete' event to a <a class="el" href="classOgre_1_1Resource_1_1Listener.html">Resource::Listener</a> event.  <a href="#d47c5ba2a6253b0fdb0aa9bf9d92f8f7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#26eff0a3702469fb1c18ecb30589aa76">_fireBackgroundLoadingComplete</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Fires all the queued events for background loaded resources.  <a href="#26eff0a3702469fb1c18ecb30589aa76"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <br>
<a class="el" href="classOgre_1_1ResourceBackgroundQueue.html">ResourceBackgroundQueue</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#85e23967cb7bce8948b744e0de9af17a">getSingleton</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval.  <a href="#85e23967cb7bce8948b744e0de9af17a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <br>
<a class="el" href="classOgre_1_1ResourceBackgroundQueue.html">ResourceBackgroundQueue</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#8560b1f597bcb32f13d4a0abbdbb2e02">getSingletonPtr</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval.  <a href="#8560b1f597bcb32f13d4a0abbdbb2e02"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b745">RequestType</a> { <br>
&nbsp;&nbsp;<a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b745e8ee38057ec65c7818091b1caca338ca">RT_INITIALISE_GROUP</a>, 
<a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b7459a307a52ca7851def901b0140b727a3d">RT_INITIALISE_ALL_GROUPS</a>, 
<a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b7456fc6a9ca84e7613ae861d7c432843cc9">RT_LOAD_GROUP</a>, 
<a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b7457327f4cfe781534a62de7541b5f23e15">RT_LOAD_RESOURCE</a>, 
<br>
&nbsp;&nbsp;<a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b7459d78e28a478d97ad7e7d0bbb03699fb5">RT_UNLOAD_GROUP</a>, 
<a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b745471ed9d09791d8524d9f9b838cd2da72">RT_UNLOAD_RESOURCE</a>, 
<a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b74526df4cc6f4b6772e4026c5d6a2749c3c">RT_SHUTDOWN</a>
<br>
 }</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Enumerates the type of requests.  <a href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b745">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::list<br>
&lt; <a class="el" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html">Request</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#fd755f08d1050f013d3a5bfadd1e886b">RequestQueue</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::map<br>
&lt; <a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a>,<br>
 <a class="el" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html">Request</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#7358e15601d9373f738f38f6aa7a6ad1">RequestTicketMap</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::list<br>
&lt; <a class="el" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html">QueuedNotification</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#5200e347199cb918e891d847e863feb9">NotificationQueue</a></td></tr>

<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
OGRE_AUTO_MUTEX void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#bc93b62edfd70d2da270e5994a0acdf3">queueFireBackgroundOperationComplete</a> (<a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *listener, <a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a> ticket)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Private mutex, not allowed to lock from outside.  <a href="#bc93b62edfd70d2da270e5994a0acdf3"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#fd755f08d1050f013d3a5bfadd1e886b">RequestQueue</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#c46af6540373ba361e25f6b633403fad">mRequestQueue</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Queue of requests, used to store and order requests.  <a href="#c46af6540373ba361e25f6b633403fad"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#7358e15601d9373f738f38f6aa7a6ad1">RequestTicketMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#c7dcdc6e70a2376d9e23afafeac4e145">mRequestTicketMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><a class="el" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html" title="Encapsulates a queued request for the background queue.">Request</a> lookup by ticket.  <a href="#c7dcdc6e70a2376d9e23afafeac4e145"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned long&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#e669d2a7f93ff48abdc16b26c39ecb3b">mNextTicketID</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Next ticket ID.  <a href="#e669d2a7f93ff48abdc16b26c39ecb3b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#5200e347199cb918e891d847e863feb9">NotificationQueue</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#5d1138c63255c3f1c8afac581a698530">mNotificationQueue</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Queued notifications of background loading being finished.  <a href="#5d1138c63255c3f1c8afac581a698530"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#b5b6cf0b300afba334961387909accd8">mStartThread</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Mutex to protect the background event queue].  <a href="#b5b6cf0b300afba334961387909accd8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#b6a8c0ae1544490569ef3788c5c6f08b">mThread</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dummy.  <a href="#b6a8c0ae1544490569ef3788c5c6f08b"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static T *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Singleton.html#d36ac06b409a2d580217328ef2cd3a01">ms_Singleton</a></td></tr>

<tr><td colspan="2"><br><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This abstract listener interface lets you get notifications of completed background processes instead of having to poll ticket statuses.  <a href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html">QueuedNotification</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Struct that holds details of queued notifications.  <a href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html">Request</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Encapsulates a queued request for the background queue.  <a href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html#_details">More...</a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class is used to perform <a class="el" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a> operations in a background thread. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>If threading is enabled, <a class="el" href="namespaceOgre.html">Ogre</a> will create a single background thread which can be used to load / unload resources in parallel. Only one resource will be processed at once in this background thread, but it will be in parallel with the main thread. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>The general approach here is that on requesting a background resource process, your request is placed on a queue ready for the background thread to be picked up, and you will get a 'ticket' back, identifying the request. Your call will then return and your thread can proceed, knowing that at some point in the background the operation wil be performed. In it's own thread, the resource operation will be performed, and once finished the ticket will be marked as complete. You can check the status of tickets by calling <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#7165b27dcde57a8f6d49ca40c76bb75b" title="Returns whether a previously queued process has completed or not.">isProcessComplete()</a> from your queueing thread. It is also possible to get immediate callbacks on completion, but these callbacks happen in the background loading thread (not your calling thread), so should only be used if you really understand multithreading. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>By default, when threading is enabled this class will start its own separate thread to perform the actual loading. However, if you would prefer to use your own existing thread to perform the background load, then be sure to call setStartBackgroundThread(false) before <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#8842996829730ae05d3dd06c1a8224ad" title="Initialise the background queue system.">initialise()</a> is called by <a class="el" href="classOgre_1_1Root.html#4ced16ae699e5e6b67a0c95333f21375" title="Initialises the renderer.">Root::initialise</a>. Your own thread should call _initThread immediately on startup, before any resources are loaded at all, and _doNextQueuedBackgroundProcess to process background requests. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This class will only perform tasks in a background thread if OGRE_THREAD_SUPPORT is defined to be 1. Otherwise, all methods will call their exact equivalents in <a class="el" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various...">ResourceGroupManager</a> synchronously. </dd></dl>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00081">81</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="fd755f08d1050f013d3a5bfadd1e886b"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::RequestQueue" ref="fd755f08d1050f013d3a5bfadd1e886b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::list&lt;<a class="el" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html">Request</a>&gt; <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#fd755f08d1050f013d3a5bfadd1e886b">Ogre::ResourceBackgroundQueue::RequestQueue</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00146">146</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7358e15601d9373f738f38f6aa7a6ad1"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::RequestTicketMap" ref="7358e15601d9373f738f38f6aa7a6ad1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a>, <a class="el" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html">Request</a>*&gt; <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#7358e15601d9373f738f38f6aa7a6ad1">Ogre::ResourceBackgroundQueue::RequestTicketMap</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00147">147</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="5200e347199cb918e891d847e863feb9"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::NotificationQueue" ref="5200e347199cb918e891d847e863feb9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::list&lt;<a class="el" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html">QueuedNotification</a>&gt; <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#5200e347199cb918e891d847e863feb9">Ogre::ResourceBackgroundQueue::NotificationQueue</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00175">175</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Enumeration Documentation</h2>
<a class="anchor" name="edf467d04f827459c96ba08cdf61b745"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::RequestType" ref="edf467d04f827459c96ba08cdf61b745" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b745">Ogre::ResourceBackgroundQueue::RequestType</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Enumerates the type of requests. 
<p>
<dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" name="edf467d04f827459c96ba08cdf61b745e8ee38057ec65c7818091b1caca338ca"></a><!-- doxytag: member="RT_INITIALISE_GROUP" ref="edf467d04f827459c96ba08cdf61b745e8ee38057ec65c7818091b1caca338ca" args="" -->RT_INITIALISE_GROUP</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" name="edf467d04f827459c96ba08cdf61b7459a307a52ca7851def901b0140b727a3d"></a><!-- doxytag: member="RT_INITIALISE_ALL_GROUPS" ref="edf467d04f827459c96ba08cdf61b7459a307a52ca7851def901b0140b727a3d" args="" -->RT_INITIALISE_ALL_GROUPS</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" name="edf467d04f827459c96ba08cdf61b7456fc6a9ca84e7613ae861d7c432843cc9"></a><!-- doxytag: member="RT_LOAD_GROUP" ref="edf467d04f827459c96ba08cdf61b7456fc6a9ca84e7613ae861d7c432843cc9" args="" -->RT_LOAD_GROUP</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" name="edf467d04f827459c96ba08cdf61b7457327f4cfe781534a62de7541b5f23e15"></a><!-- doxytag: member="RT_LOAD_RESOURCE" ref="edf467d04f827459c96ba08cdf61b7457327f4cfe781534a62de7541b5f23e15" args="" -->RT_LOAD_RESOURCE</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" name="edf467d04f827459c96ba08cdf61b7459d78e28a478d97ad7e7d0bbb03699fb5"></a><!-- doxytag: member="RT_UNLOAD_GROUP" ref="edf467d04f827459c96ba08cdf61b7459d78e28a478d97ad7e7d0bbb03699fb5" args="" -->RT_UNLOAD_GROUP</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" name="edf467d04f827459c96ba08cdf61b745471ed9d09791d8524d9f9b838cd2da72"></a><!-- doxytag: member="RT_UNLOAD_RESOURCE" ref="edf467d04f827459c96ba08cdf61b745471ed9d09791d8524d9f9b838cd2da72" args="" -->RT_UNLOAD_RESOURCE</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" name="edf467d04f827459c96ba08cdf61b74526df4cc6f4b6772e4026c5d6a2749c3c"></a><!-- doxytag: member="RT_SHUTDOWN" ref="edf467d04f827459c96ba08cdf61b74526df4cc6f4b6772e4026c5d6a2749c3c" args="" -->RT_SHUTDOWN</em>&nbsp;</td><td>
</td></tr>
</table>
</dl>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00122">122</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="74525d1f4e99a24afa3cc0800f0b6ce9"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::ResourceBackgroundQueue" ref="74525d1f4e99a24afa3cc0800f0b6ce9" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::ResourceBackgroundQueue::ResourceBackgroundQueue           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="407ce0c4668bdf5558e15f7f99c37fa8"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::~ResourceBackgroundQueue" ref="407ce0c4668bdf5558e15f7f99c37fa8" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::ResourceBackgroundQueue::~ResourceBackgroundQueue           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="e04ad37bc376b91bf82c7e9da403d909"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::OGRE_THREAD_SYNCHRONISER" ref="e04ad37bc376b91bf82c7e9da403d909" args="(initSync)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::ResourceBackgroundQueue::OGRE_THREAD_SYNCHRONISER           </td>
          <td>(</td>
          <td class="paramtype">initSync&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Init notification mutex (must lock before waiting on initCondition). 
<p>
Synchroniser token to wait / notify on thread init (public incase external thread) 
</div>
</div><p>
<a class="anchor" name="bc93b62edfd70d2da270e5994a0acdf3"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::queueFireBackgroundOperationComplete" ref="bc93b62edfd70d2da270e5994a0acdf3" args="(Listener *listener, BackgroundProcessTicket ticket)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual OGRE_AUTO_MUTEX void Ogre::ResourceBackgroundQueue::queueFireBackgroundOperationComplete           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *&nbsp;</td>
          <td class="paramname"> <em>listener</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a>&nbsp;</td>
          <td class="paramname"> <em>ticket</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Private mutex, not allowed to lock from outside. 
<p>
Queue the firing of the 'background loading complete' event to a <a class="el" href="classOgre_1_1Resource_1_1Listener.html">Resource::Listener</a> event. <dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The purpose of this is to allow the background loading thread to call this method to queue the notification to listeners waiting on the background loading of a resource. Rather than allow the resource background loading thread to directly call these listeners, which would require all the listeners to be thread-safe, this method implements a thread-safe queue which can be processed in the main frame loop thread each frame to clear the events in a simpler manner. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>listener</em>&nbsp;</td><td>The listener to be notified </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>ticket</em>&nbsp;</td><td>The ticket for the operation that has completed </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="ec6aec8fe94ec6bf29e8e7dc30d83319"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::setStartBackgroundThread" ref="ec6aec8fe94ec6bf29e8e7dc30d83319" args="(bool startThread)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ResourceBackgroundQueue::setStartBackgroundThread           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>startThread</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets whether or not a thread should be created and started to handle the background loading, or whether a user thread will call the appropriate hooks. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>By default, a new thread will be started to handle the background load requests. However, the application may well have some threads of its own which is wishes to use to perform the background loading as well as other tasks (for example on most platforms there will be a fixed number of hardware threads which the application will wish to work within). Use this method to turn off the creation of a separate thread if you wish, and call the _doNextQueuedBackgroundProcess method from your own thread to process background requests. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>You <b>must</b> call this method prior to initialisation. Initialisation of this class is automatically done when <a class="el" href="classOgre_1_1Root.html#4ced16ae699e5e6b67a0c95333f21375" title="Initialises the renderer.">Root::initialise</a> is called. </dd></dl>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00240">240</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b7ac1af9d48ef0177778522c5cb97a59"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::getStartBackgroundThread" ref="b7ac1af9d48ef0177778522c5cb97a59" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::ResourceBackgroundQueue::getStartBackgroundThread           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets whether or not a thread should be created and started to handle the background loading, or whether a user thread will call the appropriate hooks. 
<p>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00246">246</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8842996829730ae05d3dd06c1a8224ad"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::initialise" ref="8842996829730ae05d3dd06c1a8224ad" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ResourceBackgroundQueue::initialise           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Initialise the background queue system. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Called automatically by <a class="el" href="classOgre_1_1Root.html#4ced16ae699e5e6b67a0c95333f21375" title="Initialises the renderer.">Root::initialise</a>. </dd></dl>

</div>
</div><p>
<a class="anchor" name="e6e64b1d717c2a377a60772a5cbd8dec"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::shutdown" ref="e6e64b1d717c2a377a60772a5cbd8dec" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ResourceBackgroundQueue::shutdown           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Shut down the background queue system. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Called automatically by <a class="el" href="classOgre_1_1Root.html#dc677530cc7ef50fbd0e37d75c02e16b" title="Shuts down the system manually.">Root::shutdown</a>. </dd></dl>

</div>
</div><p>
<a class="anchor" name="2543a3c0903bb5441c3b75f3c44d6cfa"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::initialiseResourceGroup" ref="2543a3c0903bb5441c3b75f3c44d6cfa" args="(const String &amp;name, Listener *listener=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a> Ogre::ResourceBackgroundQueue::initialiseResourceGroup           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *&nbsp;</td>
          <td class="paramname"> <em>listener</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Initialise a resource group in the background. 
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1ResourceGroupManager.html#f5c901bfb116d7f70f4542bd828784f4" title="Initialises a resource group.">ResourceGroupManager::initialiseResourceGroup</a> </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The name of the resource group to initialise </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>listener</em>&nbsp;</td><td>Optional callback interface, take note of warnings in the header and only use if you understand them. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>Ticket identifying the request, use <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#7165b27dcde57a8f6d49ca40c76bb75b" title="Returns whether a previously queued process has completed or not.">isProcessComplete()</a> to determine if completed if not using listener </dd></dl>

</div>
</div><p>
<a class="anchor" name="be1b5ef553e2e9cafc6172af3f0edc1a"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::initialiseAllResourceGroups" ref="be1b5ef553e2e9cafc6172af3f0edc1a" args="(Listener *listener=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a> Ogre::ResourceBackgroundQueue::initialiseAllResourceGroups           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *&nbsp;</td>
          <td class="paramname"> <em>listener</em> = <code>0</code>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Initialise all resource groups which are yet to be initialised in the background. 
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd>ResourceGroupManager::intialiseResourceGroup </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>listener</em>&nbsp;</td><td>Optional callback interface, take note of warnings in the header and only use if you understand them. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>Ticket identifying the request, use <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#7165b27dcde57a8f6d49ca40c76bb75b" title="Returns whether a previously queued process has completed or not.">isProcessComplete()</a> to determine if completed if not using listener </dd></dl>

</div>
</div><p>
<a class="anchor" name="8caf7ad66b4c65608fa6a6dfc0b0f7cb"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::loadResourceGroup" ref="8caf7ad66b4c65608fa6a6dfc0b0f7cb" args="(const String &amp;name, Listener *listener=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a> Ogre::ResourceBackgroundQueue::loadResourceGroup           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *&nbsp;</td>
          <td class="paramname"> <em>listener</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Loads a resource group in the background. 
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1ResourceGroupManager.html#3b1d27ae4ff8fe5b9ac48f6325b727e9" title="Loads a resource group.">ResourceGroupManager::loadResourceGroup</a> </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The name of the resource group to load </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>listener</em>&nbsp;</td><td>Optional callback interface, take note of warnings in the header and only use if you understand them. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>Ticket identifying the request, use <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#7165b27dcde57a8f6d49ca40c76bb75b" title="Returns whether a previously queued process has completed or not.">isProcessComplete()</a> to determine if completed if not using listener </dd></dl>

</div>
</div><p>
<a class="anchor" name="e372f5db5fedec9648076e48407edf7c"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::unload" ref="e372f5db5fedec9648076e48407edf7c" args="(const String &amp;resType, const String &amp;name, Listener *listener=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a> Ogre::ResourceBackgroundQueue::unload           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>resType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *&nbsp;</td>
          <td class="paramname"> <em>listener</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Unload a single resource in the background. 
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1ResourceManager.html#2cf457c70ea86892b1bec52028c96237" title="Unloads a single resource by name.">ResourceManager::unload</a> </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>resType</em>&nbsp;</td><td>The type of the resource (from <a class="el" href="classOgre_1_1ResourceManager.html#4a16604e10cd71957fcce705dead9a2c" title="Gets a string identifying the type of resource this manager handles.">ResourceManager::getResourceType()</a>) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The name of the <a class="el" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a> </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="91632d515e4c42970306bb8310df5790"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::unload" ref="91632d515e4c42970306bb8310df5790" args="(const String &amp;resType, ResourceHandle handle, Listener *listener=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a> Ogre::ResourceBackgroundQueue::unload           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>resType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a>&nbsp;</td>
          <td class="paramname"> <em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *&nbsp;</td>
          <td class="paramname"> <em>listener</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Unload a single resource in the background. 
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1ResourceManager.html#2cf457c70ea86892b1bec52028c96237" title="Unloads a single resource by name.">ResourceManager::unload</a> </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>resType</em>&nbsp;</td><td>The type of the resource (from <a class="el" href="classOgre_1_1ResourceManager.html#4a16604e10cd71957fcce705dead9a2c" title="Gets a string identifying the type of resource this manager handles.">ResourceManager::getResourceType()</a>) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>handle</em>&nbsp;</td><td>Handle to the resource </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="63632d3cd174ec2ba091145199e7be42"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::unloadResourceGroup" ref="63632d3cd174ec2ba091145199e7be42" args="(const String &amp;name, Listener *listener=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a> Ogre::ResourceBackgroundQueue::unloadResourceGroup           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *&nbsp;</td>
          <td class="paramname"> <em>listener</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Unloads a resource group in the background. 
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1ResourceGroupManager.html#01166a19f261e9b4fd2908c94c829d08" title="Unloads a resource group.">ResourceGroupManager::unloadResourceGroup</a> </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The name of the resource group to load </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>Ticket identifying the request, use <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#7165b27dcde57a8f6d49ca40c76bb75b" title="Returns whether a previously queued process has completed or not.">isProcessComplete()</a> to determine if completed if not using listener </dd></dl>

</div>
</div><p>
<a class="anchor" name="b14cf2235526638f58ddbf234379219a"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::load" ref="b14cf2235526638f58ddbf234379219a" args="(const String &amp;resType, const String &amp;name, const String &amp;group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, Listener *listener=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a> Ogre::ResourceBackgroundQueue::load           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>resType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>group</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>isManual</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ManualResourceLoader.html">ManualResourceLoader</a> *&nbsp;</td>
          <td class="paramname"> <em>loader</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6">NameValuePairList</a> *&nbsp;</td>
          <td class="paramname"> <em>loadParams</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">Listener</a> *&nbsp;</td>
          <td class="paramname"> <em>listener</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Load a single resource in the background. 
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1ResourceManager.html#998612da9b363c55e3be826f2a91c25a" title="Generic load method, used to create a Resource specific to this ResourceManager without...">ResourceManager::load</a> </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>resType</em>&nbsp;</td><td>The type of the resource (from <a class="el" href="classOgre_1_1ResourceManager.html#4a16604e10cd71957fcce705dead9a2c" title="Gets a string identifying the type of resource this manager handles.">ResourceManager::getResourceType()</a>) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The name of the <a class="el" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a> </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>group</em>&nbsp;</td><td>The resource group to which this resource will belong </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>isManual</em>&nbsp;</td><td>Is the resource to be manually loaded? If so, you should provide a value for the loader parameter </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>loader</em>&nbsp;</td><td>The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter. NOTE: must be thread safe!! </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>loadParams</em>&nbsp;</td><td>Optional pointer to a list of name/value pairs containing loading parameters for this type of resource. Remember that this must have a lifespan longer than the return of this call! </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="7165b27dcde57a8f6d49ca40c76bb75b"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::isProcessComplete" ref="7165b27dcde57a8f6d49ca40c76bb75b" args="(BackgroundProcessTicket ticket)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Ogre::ResourceBackgroundQueue::isProcessComplete           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">BackgroundProcessTicket</a>&nbsp;</td>
          <td class="paramname"> <em>ticket</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns whether a previously queued process has completed or not. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This method of checking that a background process has completed is the 'polling' approach. Each queued method takes an optional listener parameter to allow you to register a callback instead, which is arguably more efficient. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>ticket</em>&nbsp;</td><td>The ticket which was returned when the process was queued </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>true if process has completed (or if the ticket is unrecognised), false otherwise </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Tickets are not stored onced complete so do not accumulate over time. This is why a non-existent ticket will return 'true'. </dd></dl>

</div>
</div><p>
<a class="anchor" name="8f60aa6699d6ea2f645cf375cf5ef817"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::_doNextQueuedBackgroundProcess" ref="8f60aa6699d6ea2f645cf375cf5ef817" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::ResourceBackgroundQueue::_doNextQueuedBackgroundProcess           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Process a single queued background operation. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>If you are using your own thread to perform background loading, calling this method from that thread triggers the processing of a single background loading request from the queue. This method will not return until the request has been fully processed. It also returns whether it did in fact process anything - if it returned false, there was nothing more in the queue. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd><b>Do not</b> call this method unless you are using your own thread to perform the background loading and called setStartBackgroundThread(false). You must only have one background loading thread. </dd></dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>true if a request was processed, false if the queue was empty. </dd></dl>

</div>
</div><p>
<a class="anchor" name="20d36a810c38446862e913444fadad85"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::_initThread" ref="20d36a810c38446862e913444fadad85" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ResourceBackgroundQueue::_initThread           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Initialise processing for a background thread. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You must call this method if you use your own thread rather than letting this class create its own. Moreover, you must call it after <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#8842996829730ae05d3dd06c1a8224ad" title="Initialise the background queue system.">initialise()</a> and after you've started your own thread, but before any resources have been loaded. There are some per-thread tasks which have to be performed on some rendering APIs and it's important that they are done before rendering resources are created. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>You must call this method in your own background thread, not the main thread. It's important to block the main thread whilst this initialisation is happening, use an OGRE_THREAD_WAIT on the public initSync token after locking the initMutex. </dd></dl>

</div>
</div><p>
<a class="anchor" name="d47c5ba2a6253b0fdb0aa9bf9d92f8f7"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::_queueFireBackgroundLoadingComplete" ref="d47c5ba2a6253b0fdb0aa9bf9d92f8f7" args="(Resource *res)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ResourceBackgroundQueue::_queueFireBackgroundLoadingComplete           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Resource.html">Resource</a> *&nbsp;</td>
          <td class="paramname"> <em>res</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Queue the firing of the 'background loading complete' event to a <a class="el" href="classOgre_1_1Resource_1_1Listener.html">Resource::Listener</a> event. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The purpose of this is to allow the background loading thread to call this method to queue the notification to listeners waiting on the background loading of a resource. Rather than allow the resource background loading thread to directly call these listeners, which would require all the listeners to be thread-safe, this method implements a thread-safe queue which can be processed in the main frame loop thread each frame to clear the events in a simpler manner. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>res</em>&nbsp;</td><td>The resource listened on </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="26eff0a3702469fb1c18ecb30589aa76"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::_fireBackgroundLoadingComplete" ref="26eff0a3702469fb1c18ecb30589aa76" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ResourceBackgroundQueue::_fireBackgroundLoadingComplete           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Fires all the queued events for background loaded resources. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself. </dd></dl>

</div>
</div><p>
<a class="anchor" name="85e23967cb7bce8948b744e0de9af17a"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::getSingleton" ref="85e23967cb7bce8948b744e0de9af17a" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html">ResourceBackgroundQueue</a>&amp; Ogre::ResourceBackgroundQueue::getSingleton           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Why do we do this? Well, it's because the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> template to work, but we actually only want it compiled into the implementation of the class based on the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#7757bd7ac3702c144502e53ad6491888">Ogre::Singleton&lt; T &gt;</a>.</p>

</div>
</div><p>
<a class="anchor" name="8560b1f597bcb32f13d4a0abbdbb2e02"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::getSingletonPtr" ref="8560b1f597bcb32f13d4a0abbdbb2e02" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html">ResourceBackgroundQueue</a>* Ogre::ResourceBackgroundQueue::getSingletonPtr           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Why do we do this? Well, it's because the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> template to work, but we actually only want it compiled into the implementation of the class based on the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#7ab51c46521b89723d6186a52a7e0d7b">Ogre::Singleton&lt; T &gt;</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="c46af6540373ba361e25f6b633403fad"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::mRequestQueue" ref="c46af6540373ba361e25f6b633403fad" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#fd755f08d1050f013d3a5bfadd1e886b">RequestQueue</a> <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#c46af6540373ba361e25f6b633403fad">Ogre::ResourceBackgroundQueue::mRequestQueue</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Queue of requests, used to store and order requests. 
<p>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00150">150</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c7dcdc6e70a2376d9e23afafeac4e145"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::mRequestTicketMap" ref="c7dcdc6e70a2376d9e23afafeac4e145" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#7358e15601d9373f738f38f6aa7a6ad1">RequestTicketMap</a> <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#c7dcdc6e70a2376d9e23afafeac4e145">Ogre::ResourceBackgroundQueue::mRequestTicketMap</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<a class="el" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html" title="Encapsulates a queued request for the background queue.">Request</a> lookup by ticket. 
<p>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00153">153</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e669d2a7f93ff48abdc16b26c39ecb3b"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::mNextTicketID" ref="e669d2a7f93ff48abdc16b26c39ecb3b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#e669d2a7f93ff48abdc16b26c39ecb3b">Ogre::ResourceBackgroundQueue::mNextTicketID</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Next ticket ID. 
<p>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00156">156</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="5d1138c63255c3f1c8afac581a698530"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::mNotificationQueue" ref="5d1138c63255c3f1c8afac581a698530" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#5200e347199cb918e891d847e863feb9">NotificationQueue</a> <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#5d1138c63255c3f1c8afac581a698530">Ogre::ResourceBackgroundQueue::mNotificationQueue</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Queued notifications of background loading being finished. 
<p>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00177">177</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b5b6cf0b300afba334961387909accd8"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::mStartThread" ref="b5b6cf0b300afba334961387909accd8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#b5b6cf0b300afba334961387909accd8">Ogre::ResourceBackgroundQueue::mStartThread</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Mutex to protect the background event queue]. 
<p>
Whether this class should start it's own thread or not 
<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00182">182</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b6a8c0ae1544490569ef3788c5c6f08b"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::mThread" ref="b6a8c0ae1544490569ef3788c5c6f08b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#b6a8c0ae1544490569ef3788c5c6f08b">Ogre::ResourceBackgroundQueue::mThread</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Dummy. 
<p>

<p>Definition at line <a class="el" href="OgreResourceBackgroundQueue_8h-source.html#l00197">197</a> of file <a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="d36ac06b409a2d580217328ef2cd3a01"></a><!-- doxytag: member="Ogre::ResourceBackgroundQueue::ms_Singleton" ref="d36ac06b409a2d580217328ef2cd3a01" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T* <a class="el" href="classOgre_1_1Singleton.html">Ogre::Singleton</a>&lt; T &gt;::<a class="el" href="classOgre_1_1Singleton.html#d36ac06b409a2d580217328ef2cd3a01">ms_Singleton</a><code> [static, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSingleton_8h-source.html#l00061">61</a> of file <a class="el" href="OgreSingleton_8h-source.html">OgreSingleton.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSingleton_8h-source.html#l00076">Ogre::Singleton&lt; Ogre::FontManager &gt;::getSingleton()</a>, <a class="el" href="OgreSingleton_8h-source.html#l00078">Ogre::Singleton&lt; Ogre::FontManager &gt;::getSingletonPtr()</a>, <a class="el" href="OgreSingleton_8h-source.html#l00064">Ogre::Singleton&lt; Ogre::FontManager &gt;::Singleton()</a>, and <a class="el" href="OgreSingleton_8h-source.html#l00074">Ogre::Singleton&lt; Ogre::FontManager &gt;::~Singleton()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreResourceBackgroundQueue_8h-source.html">OgreResourceBackgroundQueue.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:52:29 2008
</p>
</body>
</html>
